#include "Animationen.h"
#include "Arduino.h"
#include "LedStrip.h"
#include "wortuhr_func.h"
#include "Global.h"


void noAnimation();
void wipe();
void doubleWipe();
void fire();
void in();
void out();
void inOut();
void typing();
void fallingLetters();



void playAnimation() {
	Log("Animation: " + String(GLOBAL::anim));
	switch (GLOBAL::anim) {
	case 0:
		noAnimation();
		break;
	case 1:
		wipe();
		break;
	case 2:
		doubleWipe();
		break;
	case 3:
		fire();
		break;
	case 4:
		in();
		break;
	case 5:
		out();
		break;
	case 6:
		inOut();
		break;
	case 7:
		typing();
		break;
	case 8:
		fallingLetters();
		break;
	}
	clockLetters.clear();
}

void noAnimation() {
	std::list<int>::iterator it = clockLetters.begin();
	for (int i = 0; i <= 109; i++) {
		bool found = false;
		for (const int position : clockLetters) {
			if (i == position) {
				found = true;
				break;
			}
		}
		if (found) {
			strip.SetPixelColor(i, color);
		} else {
			strip.SetPixelColor(i, black);
		}
	}
	strip.Show();
}

void wipe() {

	for (int col = 0; col <= 12; col++) {
		for (int row = 0; row <= 9; row++) {

			if (col - 2 >= 0 && col - 2 <= 10) {
				bool found = false;
				for (const int position : clockLetters) {
					if (tiles.Map(col - 2, row) == position) {
						found = true;
						break;
					}
				}
				if (found) {
					SetPixelColor(tiles.Map(col - 2, row), color, true);
				}
				else {
					SetPixelColor(tiles.Map(col - 2, row), black, true);
				}

			}
			
			
			if (col - 1 >= 0 && col - 1 <= 10) {
				SetPixelColor(tiles.Map(col - 1, row), GLOBAL::animColorBefore, true);
			}
			
			
			if (col >= 0 && col <= 10) {
				SetPixelColor(tiles.Map(col, row), GLOBAL::animColor, true);
			}
			
		}
		//delay(50);
		Show();
	}
}

void doubleWipe() {
	RgbwColor current = GLOBAL::animColor;
	RgbwColor before = current;
	before.Lighten(80);
	RgbwColor after = current;
	after.Darken(40);

	for (int col = 0; col <= 12; col++) {
		for (int row = 0; row <= 9; row++) {
			if (col - 2 >= 0 && col - 2 <= 10) {
				SetPixelColor(tiles.Map(col - 2, row), black, true);
			}

			if (col - 1 >= 0 && col - 1 <= 10) {
				SetPixelColor(tiles.Map(col - 1, row), GLOBAL::animColorBefore, true);
			}
			if (col >= 0 && col <= 10) {
				SetPixelColor(tiles.Map(col, row), current, true);
			}
		}
		Show();
	}
	for (int col = 12; col >= -2; col--) {
		for (int row = 0; row <= 9; row++) {
			if (col + 2 >= 0 && col + 2 <= 10) {
				bool found = false;
				for (const int position : clockLetters) {
					if (tiles.Map(col + 2, row) == position) {
						found = true;
						break;
					}
				}
				if (found) {
					SetPixelColor(tiles.Map(col + 2, row), color, true);
				}
				else {
					SetPixelColor(tiles.Map(col + 2, row), black, true);
				}
			}
			
			if (col + 1 >= 0 && col + 1 <= 10) {
				SetPixelColor(tiles.Map(col + 1, row), GLOBAL::animColorBefore, true);
			}
			
			if (col >=0 && col <= 10) {
				SetPixelColor(tiles.Map(col, row), GLOBAL::animColor, true);
			}
		}
		Show();
	}
}

void fire() {
	for (int h = 9; h > 0; h--) {
		for (int c = 0; c < 5; c++) {
			//clearLeds();
			for (int i = 0; i < 11; i++) {
				//int max_px = random(random(h - 3, h), 9);
				int max_px = random(h , h + 4);
				if (max_px > 9) max_px = 9;
				strip.SetPixelColor(tiles.Map(i, max_px), red);
				RgbwColor lowerred = strip.GetPixelColor(tiles.Map(i, max_px));
				lowerred.Darken(random(80, 140));
				strip.SetPixelColor(tiles.Map(i, max_px - 1), lowerred);
				strip.SetPixelColor(tiles.Map(i, max_px + 1), red);
				strip.SetPixelColor(tiles.Map(i, max_px + 2), RgbColor(255, 60, 0));
				int red_height = random(2, 3);
				if (red_height == 3) strip.SetPixelColor(tiles.Map(i, max_px + 3), RgbColor(255, 60, 0));
				for (int t = max_px + 1 + red_height; t <= 9; t++) {
					strip.SetPixelColor(tiles.Map(i, t), RgbColor(255, 120, 0));
				}
				for (int t = max_px - 1; t >= 0; t--) {

					RgbwColor darker = strip.GetPixelColor(tiles.Map(i, t));
					darker.Darken(50);
					strip.SetPixelColor(tiles.Map(i, t), darker);
					//strip.SetPixelColor(tiles.Map(i, t), black);
					

				}
			}
			strip.Show();
			delay(150);
		}
	}
	for (int h = 0; h < 10; h++) {
		for (int c = 0; c < 5; c++) {
			//clearLeds();
			for (int i = 0; i < 11; i++) {
				//int max_px = random(random(h - 3, h), 9);
				int max_px = random(h, h + 4);
				if (max_px > 9) max_px = 9;
				strip.SetPixelColor(tiles.Map(i, max_px), red);
				RgbwColor lowerred = strip.GetPixelColor(tiles.Map(i, max_px));
				lowerred.Darken(random(80, 140));
				strip.SetPixelColor(tiles.Map(i, max_px - 1), lowerred);
				strip.SetPixelColor(tiles.Map(i, max_px + 1), red);
				strip.SetPixelColor(tiles.Map(i, max_px + 2), RgbColor(255, 60, 0));
				int red_height = random(2, 3);
				if (red_height == 3) strip.SetPixelColor(tiles.Map(i, max_px + 3), RgbColor(255, 60, 0));
				for (int t = max_px + 1 + red_height; t <= 9; t++) {
					strip.SetPixelColor(tiles.Map(i, t), RgbColor(255, 120, 0));
				}
				for (int t = max_px - 1; t >= 0; t--) {
					bool found = false;
					for (const int position : clockLetters) {
						if (tiles.Map(i, t) == position) {
							found = true;
							break;
						}
					}
					if (found) {
						strip.SetPixelColor(i, color);
					}
					else {
						RgbwColor darker = strip.GetPixelColor(tiles.Map(i, t));
						darker.Darken(50);
						strip.SetPixelColor(tiles.Map(i, t), darker);
						//strip.SetPixelColor(tiles.Map(i, t), black);
					}
				}
			}
			strip.Show();
			delay(150);
		}
	}
	//TODO: noch nicht funktionstchtig
}

void in() {
	for (int i = 0; i <=7; i++) {
		for (int col = 0; col <= 10; col++) {
			if (col == i || col == 10 - i) {
				for (int row = 0; row <= 9; row++) {
					if (row >= i && row <= 9 - i) {
						SetPixelColor(tiles.Map(col, row), GLOBAL::animColor, true);
					}
					else {
						if (!(row > i && row <= 9 - i && col >= i && col <= 10 - i)) {
							bool found = false;
								for (const int position : clockLetters) {
									if (tiles.Map(col, row) == position) {
										found = true;
											break;
									}
								}
							if (found) {
								SetPixelColor(tiles.Map(col, row), color, true);
							}
							else {
								SetPixelColor(tiles.Map(col, row), black, true);
							}
						}
					}
				}
			}
			else {
				for (int row = 0; row <= 9; row++) {
					if (!(row > i && row <= 9 - i && col >= i && col <= 10 - i)) {
						bool found = false;
						for (const int position : clockLetters) {
							if (tiles.Map(col, row) == position) {
								found = true;
								break;
							}
						}
						if (found) {
							SetPixelColor(tiles.Map(col, row), color, true);
						}
						else {
							SetPixelColor(tiles.Map(col, row), black, true);
						}
					}
				}
			}
			
		}
		for (int row = 0; row <= 9; row++) {
			if (row == i || row == 9 - i) {
				for (int col = 0; col <= 10; col++) {
					if (col >= i && col <= 10 - i) {
						SetPixelColor(tiles.Map(col, row), GLOBAL::animColor);
					} else {
						if (!(row > i && row <= 9 - i && col >= i && col <= 10 - i)) {
							bool found = false;
							for (const int position : clockLetters) {
								if (tiles.Map(col, row) == position) {
									found = true;
									break;
								}
							}
							if (found) {
								SetPixelColor(tiles.Map(col, row), color, true);
							}
							else {
								SetPixelColor(tiles.Map(col, row), black, true);
							}
						}
					}
				}
			}
		}
		Show();
	}

}

void out() {
	for (int i = 5; i >= -3; i--) {
		for (int col = 0; col <= 10; col++) {
			if (col == i || col == 10 - i) {
				for (int row = 0; row <= 9; row++) {
					if (row >= i && row <= 9 - i) {
						SetPixelColor(tiles.Map(col, row), GLOBAL::animColor, true);
					}
					else {
						if (row > i && row < 9 - i && col > i && col < 10 - i) {
							bool found = false;
							for (const int position : clockLetters) {
								if (tiles.Map(col, row) == position) {
									found = true;
									break;
								}
							}
							if (found) {

								SetPixelColor(tiles.Map(col, row), color, true);

							}
							else {
								SetPixelColor(tiles.Map(col, row), black, true);
							}
						}
					}
				}
			}
			else {
				for (int row = 0; row <= 9; row++) {
					if (row > i && row < 9 - i && col > i && col < 10 - i) {
						bool found = false;
						for (const int position : clockLetters) {
							if (tiles.Map(col, row) == position) {
								found = true;
								break;
							}
						}
						if (found) {

							SetPixelColor(tiles.Map(col, row), color, true);

						}
						else {
							SetPixelColor(tiles.Map(col, row), black, true);
						}
					}
				}
			}
		}

		for (int row = 0; row <= 9; row++) {
			if (row == i || row == 9 - i) {
				for (int col = 0; col <= 10; col++) {
					if (col >= i && col <= 10 - i) {
						SetPixelColor(tiles.Map(col, row), GLOBAL::animColor);
					}
					else {
						if (row > i && row < 9 - i && col > i && col < 10 - i) {
							bool found = false;
							for (const int position : clockLetters) {
								if (tiles.Map(col, row) == position) {
									found = true;
									break;
								}
							}
							if (found) {

								SetPixelColor(tiles.Map(col, row), color, true);

							}
							else {
								SetPixelColor(tiles.Map(col, row), black, true);
							}
						}
					}
				}
			}
		}
		Show();
	}
}

void inOut() {
	for (int i = 0; i <= 6; i++) {
		for (int col = 0; col <= 10; col++) {
			if (col == i || col == 10 - i) {
				for (int row = 0; row <= 9; row++) {
					if (row >= i && row <= 9 - i) {
						SetPixelColor(tiles.Map(col, row), GLOBAL::animColor, true);
					}else {
						SetPixelColor(tiles.Map(col, row), black, true);
					}
				}
			} else {
				for (int row = 0; row <= 9; row++) {
					if (row < i || row > 9 - i) {
						SetPixelColor(tiles.Map(col, row), black, true);
					}
				}
			}
		}
		
		for (int row = 0; row <= 9; row++) {
			if (row == i || row == 9 - i) {
				for (int col = 0; col <= 10; col++) {
					if (col >= i && col <= 10 - i) {
						SetPixelColor(tiles.Map(col, row), GLOBAL::animColor);
					} else {
						SetPixelColor(tiles.Map(col, row), black, true);
					}
				}
			} else {
				for (int col = 0; col <= 10; col++) {
					if (col < i || col > 10 - i) {
						SetPixelColor(tiles.Map(col, row), black, true);
					}
				}
			}
		}
		Show();
	}
	out();
}

void typing() {
	for (int i = 0; i <= 109; i++) {
		SetPixelColor(i, black, true);
	}
	Show();
	for (const int position : clockLetters) {
		SetPixelColor(position, GLOBAL::animColor, false);
		Show();
		delay(75);
		SetPixelColor(position, color);
		Show();
		delay(150);
	}
}

void fallingLetters() {
	for (const int position : clockLetters) {
		for (int pos = 0; pos < position;pos++) {
			for (int i = 0; i <= 109; i++) {
				if (i > position) SetPixelColor(i, black, false);
			}
			SetPixelColor(pos, GLOBAL::animColor, true);
			Show();
			delay(20);
		}
		SetPixelColor(position, GLOBAL::animColor, true);
		Show();
		delay(75);
		SetPixelColor(position, color);
		Show();
		delay(150);
		//TODO: noch nicht funktionstchtig
	}
}

Animationen::Animationen()
{
}


Animationen::~Animationen()
{
}
