
#define pixelCount 114            //number of pixels in RGB strip

NeoPixelBrightnessBus<NeoGrbwFeature, NeoSk6812Method> strip(pixelCount, RX);  //GPIO 0

// make sure to set these panel values to the sizes of yours
const uint8_t PanelWidth = 11;  // 8 pixel x 8 pixel matrix of leds
const uint8_t PanelHeight = 10;
const uint8_t TileWidth = 1;  // laid out in 4 panels x 2 panels mosaic
const uint8_t TileHeight = 1;

typedef RowMajorAlternating180Layout MyPanelLayout;
typedef ColumnMajorLayout MyTilesLayout;
NeoTiles <MyPanelLayout, MyTilesLayout> tiles(PanelWidth,PanelHeight,TileWidth,TileHeight);

RgbColor red(128, 0, 0);
RgbColor green(0, 128, 0);
RgbColor blue(0, 0, 128);
RgbColor whitergb(255, 255, 255);
RgbwColor white(128);

RgbwColor color = white;
int brightness = 128; //0-255

int laststep = -1;
int last_minstep = -1;

//char clockText[50];
String clockText;

String EsIst();
String pre_fuenf();
String pre_zehn();
String zwanzig();
//void drei();
String viertel();
String nach();
String vor();
String halb();
String zwoelf();
String zwei();
String eins();
String ein();
String sieben();
String drei();
String fuenf();
String elf();
String neun();
String vier();
String acht();
String zehn();
String sechs();
String uhr();
String Stunde();
String Stunde(bool pluseins, bool voll);

void wordClock() {
  int int_hour = hourFormat12();
  int int_minute = minute();

// Minuten LEDS
  int minstep = int_minute % 5;
  if (last_minstep != minstep) {
    switch(int_minute % 5) {
      case 1:
        strip.SetPixelColor(110, color);
        //Log("Minute 1");
        break;
      case 2:
        strip.SetPixelColor(113, color);
        //Log("Minute 2");
        break;
      case 3:
        strip.SetPixelColor(112, color);
        //Log("Minute 3");
        break;
      case 4:
        strip.SetPixelColor(111, color);
        //Log("Minute 4");
        break;
    }
    last_minstep = minstep;
  }

  int step = int_minute / 5;

  if (laststep != step) {
    clockText = "";
    clockText += EsIst();
    switch(step) {
      case 1:
        clockText += pre_fuenf() + nach() + Stunde();
        break;
      case 2:
        clockText += pre_zehn() + nach() + Stunde();
        break;
      case 3:
        clockText += viertel() + nach() + Stunde();
        break;
      case 4:
        clockText += zwanzig() + nach() + Stunde();
        break;
      case 5:
        clockText += pre_fuenf() + vor() + halb() + Stunde(true, false);
        break;
      case 6:
        clockText += halb() + Stunde(true, false);
        break;
      case 7:
        clockText += pre_fuenf() + nach() + halb() + Stunde(true, false);
        break;
      case 8:
        clockText += zwanzig() + vor() + Stunde(true, false);
        break;
      case 9:
        clockText += viertel() + vor() + Stunde(true, false);
        break;
      case 10:
        clockText += zehn() + vor() + Stunde(true, false);
        break;
      case 11:
        clockText += pre_fuenf() + vor() + Stunde(true, false);
        break;
      default:
        clockText += Stunde(false, true) + uhr(); 
    }
    Log(clockText);
    laststep = step;
  }
  
  strip.SetBrightness(brightness);
  strip.Show();
  
}

String EsIst() {
  strip.SetPixelColor(tiles.Map(0, 0), color);
  strip.SetPixelColor(tiles.Map(1, 0), color);

  strip.SetPixelColor(tiles.Map(3, 0), color);
  strip.SetPixelColor(tiles.Map(4, 0), color);
  strip.SetPixelColor(tiles.Map(5, 0), color);
  return "Es ist ";
}

String pre_fuenf() {
  strip.SetPixelColor(tiles.Map(7, 0), color);
  strip.SetPixelColor(tiles.Map(8, 0), color);
  strip.SetPixelColor(tiles.Map(9, 0), color);
  strip.SetPixelColor(tiles.Map(10, 0), color);
  return "fünf ";
}

String pre_zehn() {
  strip.SetPixelColor(tiles.Map(0, 1), color);
  strip.SetPixelColor(tiles.Map(1, 1), color);
  strip.SetPixelColor(tiles.Map(2, 1), color);
  strip.SetPixelColor(tiles.Map(3, 1), color);
  return "zehn ";
}

String zwanzig() {
  strip.SetPixelColor(tiles.Map(4, 1), color);
  strip.SetPixelColor(tiles.Map(5, 1), color);
  strip.SetPixelColor(tiles.Map(6, 1), color);
  strip.SetPixelColor(tiles.Map(7, 1), color);
  strip.SetPixelColor(tiles.Map(8, 1), color);
  strip.SetPixelColor(tiles.Map(9, 1), color);
  strip.SetPixelColor(tiles.Map(10, 1), color);
  return "zwanzig ";
}

//void drei() {
//  strip.SetPixelColor(tiles.Map(0, 2), color);
//  strip.SetPixelColor(tiles.Map(1, 2), color);
//  strip.SetPixelColor(tiles.Map(2, 2), color);
//  strip.SetPixelColor(tiles.Map(3, 2), color);
//}

String viertel() {
  strip.SetPixelColor(tiles.Map(4, 2), color);
  strip.SetPixelColor(tiles.Map(5, 2), color);
  strip.SetPixelColor(tiles.Map(6, 2), color);
  strip.SetPixelColor(tiles.Map(7, 2), color);
  strip.SetPixelColor(tiles.Map(8, 2), color);
  strip.SetPixelColor(tiles.Map(9, 2), color);
  strip.SetPixelColor(tiles.Map(10, 2), color);
  return "viertel ";
}

String nach() {
  strip.SetPixelColor(tiles.Map(2, 3), color);
  strip.SetPixelColor(tiles.Map(3, 3), color);
  strip.SetPixelColor(tiles.Map(4, 3), color);
  strip.SetPixelColor(tiles.Map(5, 3), color);
  return "nach ";
}

String vor() {
  strip.SetPixelColor(tiles.Map(6, 3), color);
  strip.SetPixelColor(tiles.Map(7, 3), color);
  strip.SetPixelColor(tiles.Map(8, 3), color);
  return "vor ";
}

String halb() {
  strip.SetPixelColor(tiles.Map(0, 4), color);
  strip.SetPixelColor(tiles.Map(1, 4), color);
  strip.SetPixelColor(tiles.Map(2, 4), color);
  strip.SetPixelColor(tiles.Map(3, 4), color);
  strip.SetPixelColor(tiles.Map(4, 4), color);
  return "halb ";
}

String zwoelf() {
  strip.SetPixelColor(tiles.Map(5, 4), color);
  strip.SetPixelColor(tiles.Map(6, 4), color);
  strip.SetPixelColor(tiles.Map(7, 4), color);
  strip.SetPixelColor(tiles.Map(8, 4), color);
  strip.SetPixelColor(tiles.Map(9, 4), color);
  return "zwölf ";
}

String zwei() {
  strip.SetPixelColor(tiles.Map(0, 5), color);
  strip.SetPixelColor(tiles.Map(1, 5), color);
  strip.SetPixelColor(tiles.Map(2, 5), color);
  strip.SetPixelColor(tiles.Map(3, 5), color);
  return "zwei ";
}

String eins() {
  strip.SetPixelColor(tiles.Map(2, 5), color);
  strip.SetPixelColor(tiles.Map(3, 5), color);
  strip.SetPixelColor(tiles.Map(4, 5), color);
  strip.SetPixelColor(tiles.Map(5, 5), color);
  return "eins ";
}

String ein() {
  strip.SetPixelColor(tiles.Map(2, 5), color);
  strip.SetPixelColor(tiles.Map(3, 5), color);
  strip.SetPixelColor(tiles.Map(4, 5), color);
  return "ein ";
}

String sieben() {
  strip.SetPixelColor(tiles.Map(5, 5), color);
  strip.SetPixelColor(tiles.Map(6, 5), color);
  strip.SetPixelColor(tiles.Map(7, 5), color);
  strip.SetPixelColor(tiles.Map(8, 5), color);
  strip.SetPixelColor(tiles.Map(9, 5), color);
  strip.SetPixelColor(tiles.Map(10, 5), color);
  return "sieben ";
}

String drei() {
  strip.SetPixelColor(tiles.Map(1, 6), color);
  strip.SetPixelColor(tiles.Map(2, 6), color);
  strip.SetPixelColor(tiles.Map(3, 6), color);
  strip.SetPixelColor(tiles.Map(4, 6), color);
  return "drei ";
}

String fuenf() {
  strip.SetPixelColor(tiles.Map(7, 6), color);
  strip.SetPixelColor(tiles.Map(8, 6), color);
  strip.SetPixelColor(tiles.Map(9, 6), color);
  strip.SetPixelColor(tiles.Map(10, 6), color);
  return "fünf ";
}

String elf() {
  strip.SetPixelColor(tiles.Map(0, 7), color);
  strip.SetPixelColor(tiles.Map(1, 7), color);
  strip.SetPixelColor(tiles.Map(2, 7), color);
  return "elf ";
}

String neun() {
  strip.SetPixelColor(tiles.Map(3, 7), color);
  strip.SetPixelColor(tiles.Map(4, 7), color);
  strip.SetPixelColor(tiles.Map(5, 7), color);
  strip.SetPixelColor(tiles.Map(6, 7), color);
  return "neun ";
}

String vier() {
  strip.SetPixelColor(tiles.Map(7, 7), color);
  strip.SetPixelColor(tiles.Map(8, 7), color);
  strip.SetPixelColor(tiles.Map(9, 7), color);
  strip.SetPixelColor(tiles.Map(10, 7), color);
  return "vier ";
}

String acht() {
  strip.SetPixelColor(tiles.Map(1, 8), color);
  strip.SetPixelColor(tiles.Map(2, 8), color);
  strip.SetPixelColor(tiles.Map(3, 8), color);
  strip.SetPixelColor(tiles.Map(4, 8), color);
  return "acht ";
}

String zehn() {
  strip.SetPixelColor(tiles.Map(5, 8), color);
  strip.SetPixelColor(tiles.Map(6, 8), color);
  strip.SetPixelColor(tiles.Map(7, 8), color);
  strip.SetPixelColor(tiles.Map(8, 8), color);
  return "zehn ";
}

String sechs() {
  strip.SetPixelColor(tiles.Map(1, 9), color);
  strip.SetPixelColor(tiles.Map(2, 9), color);
  strip.SetPixelColor(tiles.Map(3, 9), color);
  strip.SetPixelColor(tiles.Map(4, 9), color);
  strip.SetPixelColor(tiles.Map(5, 9), color);
  return "sechs ";
}

String uhr() {
  strip.SetPixelColor(tiles.Map(8, 9), color);
  strip.SetPixelColor(tiles.Map(9, 9), color);
  strip.SetPixelColor(tiles.Map(10, 9), color);
  return "Uhr";
}

String Stunde() {
  return Stunde(false, false);
}

String Stunde(bool pluseins, bool voll = false) {
  int int_hour = hourFormat12();
  if (pluseins) {
    int_hour++;
    if (int_hour == 13) int_hour = 1;
  }

  fireTransition();

  switch(int_hour) {
    case 1:
      if (voll) {
        return ein();
      } else {
        return eins();
      }
      break;
    case 2:
      return zwei();
      break;
    case 3:
      return drei();
      break;
    case 4:
      return vier();
      break;
    case 5:
      return fuenf();
      break;
    case 6:
      return sechs();
      break;
    case 7:
      return sieben();
      break;
    case 8:
      return acht();
      break;
    case 9:
      return neun();
      break;
    case 10:
      return zehn();
      break;
    case 11:
      return elf();
      break;
    case 12:
      return zwoelf();
      break;
  }
}

void LedTest() {
	int brightness = strip.GetBrightness();
	strip.SetBrightness(20);
	for (int x = 0; x < pixelCount; x++) {
		Serial.println("LED-Test: " + String(x));
		strip.SetPixelColor(x, color);
		strip.Show();
		delay(300);
	}
	strip.SetBrightness(brightness);
}

void DumpTopo()
{
    Serial.println();

    Serial.print("\t\t");
    for (int x = 0; x < tiles.getWidth(); x++)
    {
        Serial.print(x);
        Serial.print("\t");
    }
    Serial.println();

    Serial.print("\t---");
    for (int x = 0; x < tiles.getWidth(); x++)
    {
        Serial.print("--------");
    }
    Serial.println();

    for (int y = 0; y < tiles.getHeight(); y++)
    {
        Serial.print("  ");
        Serial.print(y);
        Serial.print("\t|\t");

        for (int x = 0; x < tiles.getWidth(); x++)
        {
            NeoTopologyHint hint = tiles.TopologyHint(x, y);

            Serial.print(tiles.Map(x, y));
            if (hint == NeoTopologyHint_FirstOnPanel)
            {
                Serial.print("<");
            }
            else if (hint == NeoTopologyHint_LastOnPanel)
            {
                Serial.print(">");
            }
            Serial.print("\t");
        }
        Serial.println();
    }
}
